[Date Prev][Date Next] [Thread Prev][Thread Next] [Date Index] [Thread Index]

Re: [PATCH] More resilient detachment of loopback devices



On Thu, Jul 21, 2011 at 10:30 AM, Cody A.W. Somerville <cody.somerville@canonical.com> wrote:
Hello,

Please accept this patch which makes the following changes to make detachment of loopback devices while building usb images more resilient:
<snip>

Please accept this updated patch which I've rebased on top of my changes to fix the usb corruption issue.

Cheers,

--
Cody A.W. Somerville
Release Engineer
Foundations Team
Custom Engineering Solutions Group
Canonical OEM Services
Phone: +1 781 850 2087
Cell: +1 613 401 5141
Fax: +1 613 687 7368
Email: cody.somerville@canonical.com
=== modified file 'functions/losetup.sh'
--- functions/losetup.sh	2011-03-09 18:20:42 +0000
+++ functions/losetup.sh	2011-07-21 14:17:06 +0000
@@ -7,6 +7,29 @@
 ## This is free software, and you are welcome to redistribute it
 ## under certain conditions; see COPYING for details.
 
+Lodetach ()
+{
+	DEVICE="${1}"
+	ATTEMPT="${2:-1}"
+
+	if [ "${ATTEMPT}" -gt 3 ]
+	then
+		Echo_error "Failed to detach loop device '${DEVICE}'."
+		exit 1
+	fi
+
+	# Changes to block devices result in uevents which trigger rules which in
+	# turn access the loop device (ex. udisks-part-id, blkid) which can cause
+	# a race condition. We call 'udevadm settle' to help avoid this.
+	${LB_ROOT_COMMAND} udevadm settle
+
+	# Loop back devices aren't the most reliable when it comes to writes.
+	# We sleep and sync for good measure - better than build failure.
+	sync
+	sleep 1
+
+	${LB_ROOT_COMMAND} ${LB_LOSETUP} -d "${DEVICE}" || Lodetach "${DEVICE}" "$(expr ${ATTEMPT} + 1)"
+}
 
 Losetup ()
 {
@@ -14,9 +37,9 @@
 	FILE="${2}"
 	PARTITION="${3:-1}"
 
-	${LB_ROOT_COMMAND} ${LB_LOSETUP} "${DEVICE}" "${FILE}"
+	${LB_ROOT_COMMAND} ${LB_LOSETUP} --read-only "${DEVICE}" "${FILE}"
 	FDISK_OUT="$(${LB_FDISK} -l -u ${DEVICE} 2>&1)"
-	${LB_ROOT_COMMAND} ${LB_LOSETUP} -d "${DEVICE}"
+	Lodetach "${DEVICE}"
 
 	LOOPDEVICE="$(echo ${DEVICE}p${PARTITION})"
 

=== modified file 'scripts/build/lb_binary_usb'
--- scripts/build/lb_binary_usb	2011-07-19 19:12:21 +0000
+++ scripts/build/lb_binary_usb	2011-07-21 14:49:26 +0000
@@ -164,8 +164,7 @@
 		;;
 esac
 
-sleep 1
-${LB_LOSETUP} -d ${FREELO}
+Lodetach ${FREELO}
 
 FREELO="$(${LB_LOSETUP} -f)"
 Losetup $FREELO chroot/binary.img 1
@@ -254,8 +253,7 @@
 	esac
 fi
 
-sleep 1
-${LB_LOSETUP} -d ${FREELO}
+Lodetach ${FREELO}
 
 echo "!!! The above error/warning messages can be ignored !!!"
 
@@ -274,8 +272,7 @@
 		;;
 esac
 
-sleep 1
-${LB_LOSETUP} -d ${FREELO}
+Lodetach ${FREELO}
 
 if [ -n "${MAKEDEV}" ]
 then

=== modified file 'scripts/build/lb_source_usb'
--- scripts/build/lb_source_usb	2011-07-19 19:12:21 +0000
+++ scripts/build/lb_source_usb	2011-07-21 14:48:59 +0000
@@ -93,8 +93,7 @@
 Losetup $FREELO source.img 0
 Chroot chroot "parted -s ${FREELO} mklabel msdos" || true
 Chroot chroot "parted -s ${FREELO} mkpart primary ${PARTITION_TYPE} 0.0 100%" || true
-sleep 1
-${LB_LOSETUP} -d ${FREELO}
+Lodetach ${FREELO}
 
 Losetup $FREELO source.img 1
 
@@ -122,15 +121,13 @@
 cp -r source/* source.tmp
 ${LB_ROOT_COMMAND} umount source.tmp
 rmdir source.tmp
-sleep 1
-${LB_LOSETUP} -d ${FREELO}
+Lodetach ${FREELO}
 Echo_warning "!!! The above error/warning messages can be ignored !!!"
 
 FREELO="$(${LB_LOSETUP} -f)"
 Losetup "$FREELO" source.img 0
 Chroot chroot "parted -s ${FREELO} set 1 lba off" || true
-sleep 1
-${LB_LOSETUP} -d ${FREELO}
+Lodetach ${FREELO}
 
 if [ -n "${MAKEDEV}" ]
 then


Reply to: